package introExam.LinkedList;

import introExam.LinkedList.LL;


/************************************************
These methods are the candidates for the linked list question
*************************************************/


public class ExtendedLL extends LL {

  /**
   * Inserts a newItem into the list at the location immediately after 
   * the first item that matches keyItem.  It does not remove or damage 
   * any item already in the list.
   * <p>
   * In the event of an error, it does not change the list, instead it
   * returns leaving the list in its prior condition. 
   * <p>
   * @param  keyItem  the item that marks the position in the list
   * @param  newItem  the item to insert immediately after keyItem
   */
  public void insertItemAfter (Comparable keyItem, Comparable newItem) {

    return;  // Remove this!
  }


  /**
   * Inserts a newItem into the list at the location immediately prior to 
   * the first item that matches keyItem. It does not remove or damage any 
   * item already in the list.
   * <p>
   * In the event of an error, it does not change the list, instead it
   * returns leaving the list in its prior condition. 
   * <p>
   * @param  keyItem  the item that marks the position in the list
   * @param  newItem  the item to insert immediately prior to keyItem
   */
  public void insertItemBefore (Comparable keyItem, Comparable newItem) {

    return;  // Remove this!
  } 


  /**
   * Removes the item at the specified index from the list. The list's 
   * numbering begins with 0.
   * <p>
   * In the event of an error, it does not change the list, instead it
   * returns leaving the list in its prior condition. 
   * <p>
   * @param  index  the index, a.k.a. position, of the item in the list
   */
  public void removeItemAt (int index) {

    return;  // Remove this!
  } 


  /**
   * Removes the first item equal to the keyItem from the list. 
   * This method removes at most one item. If there are multiple matching 
   * items, it removes only the matching item closest to the head. 
   * The list is not changed in any other way.
   * <p>
   * In the event of an error, it does not change the list, instead it
   * returns leaving the list in its prior condition. 
   * <p>
   * @param  keyItem  The first item within the list equal to this item is
   *                   removed from the list.
   */
   public void removeFirstMatchingItem (Comparable keyItem) {

    return;  // Remove this!
   } 


  /**
   * Removes each and every item equal to the keyItem from the list. 
   * The list is not changed in any other way.
   * <p>
   * In the event of an error, it does not change the list, instead it
   * returns leaving the list in its prior condition. 
   * <p>
   * @param  keyItem  Each and every item within the list equal to this 
   *                  item is removed from the list.
   */
  public void removeAllMatchingItems (Comparable keyItem) {

    return;  // Remove this!
  } 


  /**
   * Removes each and every item greater than the keyItem from the list. 
   * The list is not changed in any other way.
   * <p>
   * In the event of an error, it does not change the list, instead it
   * returns leaving the list in its prior condition. 
   * <p>
   * @param  keyItem  Each and every item within the list greater than  
   *                  this item is removed from the list.
   */
  public void removeAllGreaterItems (Comparable keyItem) {

    return;  // Remove this!
  } 


  /**
   * Removes items with odd indexes from the list. The first item
   * in the list has index 0, the second index 1, &c. The 0th index 
   * is not to considered an odd index. 
   * <p>
   * In the event of an error, it does not change the list, instead it
   * returns leaving the list in its prior condition. 
   */
  public void removeOddItems () {

    return;  // Remove this!
  } 


  /**
   * This removes items with even indexes from the list. The first item
   * in the list is at index 0, the second is at index 1, &c. The 0th index 
   * is considered an even index for the purpose of this method. 
   * <p>
   * In the event of an error, it does not change the list, instead it
   * returns leaving the list in its prior condition. 
   */
  public void removeEvenItems () {

    return;  // Remove this!
  }

   
  /**
   * This method swaps the first and last items in the list.
   * It does not affect the order or location of any items other
   * than the first and last items. A one item list remains
   * unchanged.
   * <p>
   * In the event of an error, it does not change the list, instead it
   * returns leaving the list in its prior condition. 
   */
  public void swapFirstAndLast () {

    return;  // Remove this!
  }
  
  
    /**
   * Creates and returns a new list, which contains exactly those items 
   * that are not present in this list, but that are present in the otherList.
   * <p>
   * This method does not change either of the original lists.
   * <p>
   * In the event of an error, it returns an empty list. 
   * <p>
   * @param  otherList is the list to be compared with this list
   * <p>
   * @return A list containing all items that are not present in this list
   * but that are present in the otherList.
   */
  public ExtendedLL getItemsNotPresent(ExtendedLL otherList) { 

    return null; // Remove this! 
  }



  /**
   * Creates and returns a new list, which contains exactly those items 
   * that are present in both lists
   * <p>
   * Each original list may have duplicate items, but the resulting
   * list should have no more than one instance of each item
   * <p>
   * This method does not change either of the original lists
   * <p>
   * In the event of an error, it returns an empty list. 
   * <p>
   * @param  otherList is the list to be compared with this list
   * <p>
   * @return A new list, which contains exactly those items 
   * that are present in both lists
   */
  public ExtendedLL intersection(ExtendedLL otherList) {

    return null; // Remove this! 
  } 



  /**
   * Creates and returns a new list, which contains exactly those items 
   * that are present in exactly one of the two lists, but not both.
   * <p>
   * Each original list may have duplicate items, but the resulting
   * list should have no more than one instance of each item
   * <p>
   * It does not change either of the original lists
   * <p>
   * In the event of an error, it returns an empty list. 
   * <p>
   * @param  otherList is the list that should be compared with this list
   * <p>
   * @return  a new list, which contains exactly those items 
   * that are present in exactly one of the two lists, but not both.
   */
  public ExtendedLL xOr(ExtendedLL otherList) {

    return null; // Remove this! 
  }

 
  /**
   * This method returns true if and only if the otherList is a subset of 
   * this list and false otherwise. One list is a subset of the other 
   * list if it has exactly the same items, or some of the items, but 
   * no extra items. 
   * <p>
   * The equality of items is evaluated by equals() or compareTo()
   * on the item contained within the list.
   * <P>
   * This method is not sensitive to duplicate instances of an item in
   * either list. For example, {a, a, b} is a subset of {a, b} and
   * {a, b} is a subset of {a, a, b}
   * <p>
   * This method does not change either of the two lists.
   * <p>
   * In the event of an error, it returns false.
   * <p>
   * @param  otherList is the list to be compared to this list
   * <p>
   * @return true if the otherList is a subset of the target list, 
   * false otherwise
   */
  public boolean isSubset(ExtendedLL otherList) { 

    return false; // Remove this!
  }



  /**
   * Creates and returns a new linked list referencing the same
   * items as the original list, except organizing them in the opposite
   * order. For example, the last item in the original list is the first 
   * item in the resulting list and vice versa.
   * <p>
   * In the event of an error, it returns null.
   * <p>
   * @return A linked list referencing exactly the same items as the
   *         original, except in the reverse order. Empty if originally
   *         empty.
   */
  public ExtendedLL reverse() {
  
    return null; // Remove this!
  } 
 
}
